(define-module (ui control ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :export (on-load))

(define (ui-read-help)
  (catch/message
    (lambda()
      (form-update-value-list
	'("help")
	(woo-call "/control/read_help"
		  'mode (form-value "mode")
		  'name (form-value "name"))))))

(define (ui-read-facility)
  (catch/message
    (lambda()
      (form-update-enum
	"mode"
	(woo-call "/control/list_state" 'name (form-value "name")))
      (form-update-value-list
	'("mode")
	(woo-call "/control/read_state" 'name (form-value "name")))
      (ui-read-help))))

(define (ui-write-facility)
  (catch/message
    (lambda()
      (woo-call "/control/write_state"
		'language (form-value "language")
		'mode (form-value "mode")
		'name (form-value "name"))
      (ui-read-facility))))

(define (ui-list)
  (let ((facility-list (woo-call "/control/list_facility")))
    (form-update-enum "name" facility-list)
    (or (null? facility-list)
	(let ((name (woo-get-option (car facility-list) 'name)))
	  (form-update-value "name" name)
	  (ui-read-facility)))))

(define (on-load)
  (ui-list)
  (form-bind "name" "change" ui-read-facility)
  (form-bind "mode" "change" ui-read-help)
  (form-bind "apply_button" "click" ui-write-facility))
